/*
 * Liste natürlicher Zahlen basierend auf Arrays.
 */
public class ArrayList {

    /*
     * Enthält die Elemente der Liste.
     */
    private int[] data;

    /*
     * Erzeugt eine leere Liste.
     */
    public ArrayList() {
	this.data = new int[0];
    }

    /*
     * Erzeugt eine Liste mit dem als Argument ('dataArg') übergebenen Inhalt.
     */
    private ArrayList(int[] dataArg) {
        this.data = dataArg;
    }

    /*
     * Testet, ob die Liste leer ist.
     */
    public boolean isEmpty() {
        // TODO Hausaufgabe
    }

    /*
     * Liefert das Element der Liste zurück, das sich an der durch das Argument
     * 'index' bezeichneten Position befindet.
     * 
     * Der index soll nicht negativ, aber kleiner als die Länge der Liste sein.
     * Andernfalls wird '-1' zurückgegeben.
     */
    public int get(int index) {
        // TODO Hausaufgabe
    }

    /*
     * Liefert eine Liste zurück, deren Inhalt dieser Liste mit dem
     * zusätzlichen, letzten Element 'newElement' entspricht. Die alte Liste
     * bleibt dabei unverändert.
     * 
     * Das neue Element soll nicht negativ sein. Andernfalls wird 'null'
     * zurückgegeben.
     *
     * Beispiel: [1, 3, 2].append(4) = [1, 3, 2, 4]
     */
    public ArrayList append(int newElement) {
        // TODO Hausaufgabe
    }

    /*
     * Liefert das erste Element der Liste zurück.
     * 
     * Soll nicht auf leeren Listen aufgerufen werden. In diesem Fall wird '-1'
     * zurückgegeben.
     */
    public int head() {
        // TODO Hausaufgabe
    }

    /*
     * Liefert eine Liste zurück, deren Inhalt dieser Liste ohne ihr erstes
     * Element entspricht. Die alte Liste bleibt dabei unverändert.
     * 
     * Soll nicht auf leeren Listen aufgerufen werden. In diesem Fall wird
     * 'null' zurückgegeben.
     *
     * Beispiel: [1, 3, 2].tail() = [3, 2]
     */
    public ArrayList tail() {
        // TODO Hausaufgabe
    }

    /*
     * Liefert eine Liste zurück, deren Inhalt der Konkatenation dieser Liste
     * und der als Argument übergebenen Liste 'tail' entspricht. Die alte Liste
     * bleibt dabei unverändert.
     *
     * Beispiel: [1, 3].concat([2, 4]) = [1, 3, 2, 4]
     */
    public ArrayList concat(ArrayList tail) {
        // TODO Hausaufgabe
    }

    /*
     * Testet, ob diese Liste und die als Argument übergebene Liste 'that' die
     * gleichen Elemente in der gleichen Reihenfolge enthalten.
     */
    public boolean compare(ArrayList that) {
        // TODO Tutorium
    }

    /*
     * Testet, ob die Liste sortiert ist.
     */
    public boolean isSorted() {
        int last = 0;
        ArrayList remainder = this;
        while (!remainder.isEmpty()) {
            if (remainder.head() < last) {
                return false;
            }
            last = remainder.head();
            remainder = remainder.tail();
        }
        return true;
    }

    /*
     * Verschmilzt diese Liste mit der als Argument übergebenen Liste 'that'.
     * Sowohl diese Liste als auch die Liste 'that' müssen dazu sortiert sein.
     * Andernfalls wird 'null' zurückgegeben. Die als Ergebnis zurückgegebene
     * Liste ist sortiert und enthält alle Elemente dieser Liste und der Liste
     * 'that'.
     */
    public ArrayList merge(ArrayList that) {
        // TODO Tutorium
    }
}
